NUM_PIECE_MOD               = 38
NUM_SELECTION_MOD           = 7
NUM_TRAY_MOD                = 1
;
;Data
;
SelfModificationTables:
;
;All addresses are put together as 1 giant table to save a few bytes.
;
;The comments indicate which values are to be put into the code,
; depending on how the option that is set.
;
PieceSelfModLocationTable:
 .dw StartMod2  ;128, 32
 .dw OUMod1     ;8, 16
 .dw OUMod2     ;10, 17
 .dw OUMod3     ;2, 1
 .dw ODMod1     ;8, 16
 .dw ODMod2     ;10, 17
 .dw ODMod3     ;2, 1
 .dw OLMod1     ;10, 9
 .dw OLMod2     ;8, 16
 .dw OLMod3     ;%11111000, %11110000
 .dw ORMod1     ;107, 108
 .dw ORMod2     ;10, 9
 .dw ORMod3     ;8, 16
 .dw ORMod4     ;117, 108
 .dw ORMod5     ;0, 8
 .dw ORMod6     ;24, 16
 .dw ORMod7     ;%11111000, %11110000
 .dw SPMod1     ;%11111000, %11110000
 .dw SPMod2     ;0, 1
 .dw SPMod3     ;1, 0
 .dw SPMod4     ;1, 0
 .dw CTSMod1    ;10, 9
 .dw CTSMod2    ;49, 51
 .dw CTSMod3    ;3, 0
 .dw CTSMod4    ;22, 8
 .dw CTSPCMod   ;24, 96
 .dw CTBMod1    ;2, 1
 .dw CTBMod2    ;2, 1
 .dw DIPMod1    ;8, 16
 .dw DIPMod2    ;19, 0
 .dw CTSRMod2   ;120, 112
 .dw CTOMod2    ;107, 108
 .dw GLTSNMod   ;10, 3
 .dw RandMod1   ;%01111111, %00001111
 .dw RandMod2   ;0, 64
 .dw DMMod1     ;8, 16
 .dw DMMod2     ;8, 16
 .dw GSAMod     ;2, 0
SelectionSelfModLocationTable:
 .dw StartMod3  ;$1C3C, $0000
 .dw KeyMod1    ;CursorDown, OutlineDown
 .dw KeyMod2    ;CursorLeft, OutlineLeft
 .dw KeyMod3    ;CursorRight, OutlineRight
 .dw KeyMod4    ;CursorUp, OutlineUp
 .dw CTSRMod1   ;CTSRCursor, CTSROutline
 .dw CTOMod1    ;$C9, $00
TraySelfModLocationTable:
 .dw StartMod1  ;0, 13
;
PieceSelfMod8x8Table:
 .db 128
 .db 8
 .db 10
 .db 2
 .db 8
 .db 10
 .db 2
 .db 10
 .db 8
 .db %11111000
 .db 107
 .db 10
 .db 8
 .db 117
 .db 0
 .db 24
 .db %11111000
 .db %11111000
 .db 0
 .db 1
 .db 1
 .db 10
 .db 49
 .db 3
 .db 22
 .db 24
 .db 2
 .db 2
 .db 8
 .db 19
 .db 120
 .db 107
 .db 10
 .db %01111111
 .db 0
 .db 8
 .db 8
 .db 2
PieceSelfMod16x16Table:
 .db 32
 .db 16
 .db 17
 .db 1
 .db 16
 .db 17
 .db 1
 .db 9
 .db 16
 .db %11110000
 .db 108
 .db 9
 .db 16
 .db 108
 .db 8
 .db 16
 .db %11110000
 .db %11110000
 .db 1
 .db 0
 .db 0
 .db 9
 .db 51
 .db 0
 .db 8
 .db 96
 .db 1
 .db 1
 .db 16
 .db 0
 .db 112
 .db 108
 .db 3
 .db %00011111
 .db 128
 .db 16
 .db 16
 .db 0
SelectionSelfModCursorTable:
 .dw $1C3C
 .dw CursorDown
 .dw CursorLeft
 .dw CursorRight
 .dw CursorUp
 .dw CTSRCursor
 .dw $C9
SelectionSelfModOutlineTable:
 .dw $0000
 .dw OutlineDown
 .dw OutlineLeft
 .dw OutlineRight
 .dw OutlineUp
 .dw CTSROutline
 .dw $00
TraySelfModOnTable:
 .db 0
TraySelfModOffTable:
 .db 13
;
;End of self modification tables
;
OutlineSpriteTable1:
 .dw OutlineTopLeftSprite1
 .dw OutlineTopRightSprite1
 .dw OutlineBottomRightSprite1
 .dw OutlineBottomLeftSprite1
OutlineSpriteTable2:
 .dw OutlineTopLeftSprite2
 .dw OutlineTopRightSprite2
 .dw OutlineBottomRightSprite2
 .dw OutlineBottomLeftSprite2
;
PieceBox8x8Left:
 .db 10
 .db 8
 .db 13,50
 .db 3,50
 .db 13,40
 .db 3,40
 .db 13,30
 .db 3,30
 .db 13,20
 .db 3,20
 .db 13,10
 .db 3,10
PieceBox8x8Right:
 .db 10
 .db 8
 .db 117,50
 .db 107,50
 .db 117,40
 .db 107,40
 .db 117,30
 .db 107,30
 .db 117,20
 .db 107,20
 .db 117,10
 .db 107,10
PieceBox16x16Left:
 .db 3
 .db 16
 .db 3,43
 .db 3,26
 .db 3,9
PieceBox16x16Right:
 .db 3
 .db 16
 .db 108,43
 .db 108,26
 .db 108,9
KeyLetterTable:
 .db $2E,$26,$1E,$16,$0E
 .db $2D,$25,$1D,$15,$0D
 .db $2C,$24,$1C,$14,$0C
 .db $2B,$23,$1B,$13,$0B
 .db     $22,$1A,$12,$0A
 .db     $21,$19
;
;Sprites
;
CurveLeft:
 .db %00000111
 .db %00011111
 .db %00111111
 .db %01111111
 .db %01111111
 .db %11111111
 .db %11111111
 .db %11111111
;
CurveRight:
 .db %11100000
 .db %11111000
 .db %11111100
 .db %11111110
 .db %11111110
 .db %11111111
 .db %11111111
 .db %11111111
;
PuzzlePieceSprite1:
 .db %00011000
 .db %00111101
 .db %01111111
 .db %01111111
 .db %00111111
 .db %00011111
 .db %00111111
 .db %01111111

 .db %10000000
 .db %11000000
 .db %11100000
 .db %11100000
 .db %10000000
 .db %10001100
 .db %11001110
 .db %11111111

 .db %11111110
 .db %11111100
 .db %11111110
 .db %11111111
 .db %11111111
 .db %11011110
 .db %10001100
 .db %00000000

 .db %00111111
 .db %00011111
 .db %00111111
 .db %01111111
 .db %01111111
 .db %00111101
 .db %00011000
 .db %00000000
;
PuzzlePieceSprite2:
 .db %00000001
 .db %00000011
 .db %00000111
 .db %00000111
 .db %00000001
 .db %00110001
 .db %01110011
 .db %11111111

 .db %00011000
 .db %10111100
 .db %11111110
 .db %11111110
 .db %11111100
 .db %11111000
 .db %11111100
 .db %11111110

 .db %11111100
 .db %11111000
 .db %11111100
 .db %11111110
 .db %11111110
 .db %10111100
 .db %00011000
 .db %00000000

 .db %01111111
 .db %00111111
 .db %01111111
 .db %11111111
 .db %11111111
 .db %01111011
 .db %00110001
 .db %00000000
;
CursorSprite1:
 .db %11111100
 .db %10001000
 .db %10011000
 .db %10110100
 .db %11100010
 .db %10010001
 .db %00001010
 .db %00000100
 .db %11111100
 .db %10001000
 .db %10011000
 .db %10110100
 .db %11100010
 .db %10010001
 .db %00001010
 .db %00000100
 .db %11111100
 .db %11111000
 .db %11111000
 .db %11111100
 .db %11111110
 .db %10011111
 .db %00001110
 .db %00000100
;
CursorSprite2:
 .db %11111100
 .db %11111000
 .db %11111000
 .db %11111100
 .db %11111110
 .db %10011111
 .db %00001110
 .db %00000100
 .db %11111100
 .db %10001000
 .db %10011000
 .db %10110100
 .db %11100010
 .db %10010001
 .db %00001010
 .db %00000100
 .db %11111100
 .db %11111000
 .db %11111000
 .db %11111100
 .db %11111110
 .db %10011111
 .db %00001110
 .db %00000100
;
OutlineTopLeftSprite1:
 .db %01111000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %01100110
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %01111110
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %00000000
;
OutlineTopRightSprite1:
 .db %00011110
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %00000000
 .db %01100110
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000000
 .db %01111110
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000000
;
OutlineBottomRightSprite1:
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00011110
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %01100110
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %01111110
;
OutlineBottomLeftSprite1:
 .db %00000000
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %01111000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %01100110
 .db %00000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %01111110
;
OutlineTopLeftSprite2:
 .db %00011110
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %01100110
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %01111110
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %00000000
;
OutlineTopRightSprite2:
 .db %01111000
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000000
 .db %01100110
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000000
 .db %01111110
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000000
;
OutlineBottomRightSprite2:
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %01111000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000000
 .db %00000000
 .db %00000001
 .db %00000001
 .db %01100110
 .db %00000000
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %01111110
;
OutlineBottomLeftSprite2:
 .db %00000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %00011110
 .db %00000000
 .db %10000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %10000000
 .db %10000000
 .db %01100110
 .db %00000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %10000000
 .db %01111110
;
OptionsCursorSprite:
 .db %00001000
 .db %00001100
 .db %11111010
 .db %10001001
 .db %11111010
 .db %00001100
 .db %00001000
 .db %00000000
;
TrayArrowRightSprite:
 .db %10000000
 .db %11000000
 .db %11100000
 .db %11000000
 .db %10000000
 .db %00000000
 .db %00000000
 .db %00000000
;
TrayArrowLeftSprite:
 .db %00100000
 .db %01100000
 .db %11100000
 .db %01100000
 .db %00100000
 .db %00000000
 .db %00000000
 .db %00000000
;
TrayArrowUpSprite:
 .db %00100000
 .db %01110000
 .db %11111000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
;
TrayArrowDownSprite:
 .db %11111000
 .db %01110000
 .db %00100000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
;
;External Files
;
TitleString:
 .db 8,"JigTitle"
;
; Strings
;
NoPuzzleText:
 .db 23,34
 .db "No puzzles found.",0
MenuText:
 .db 6
 .db 0,8
 .db "Select  Puzzle",0
 .db 5
 .db 48,9
 .db "Description",0
 .db 0,76
 .db "Options: [MORE]",0
OptionsText:
 .db 3
 .db 0,8
 .db "Options",0
 .db 4
 .db 40,10
 .db "Controls",0
 .db 10,15
 .db "Piece Size:",0
 .db 19,15
 .db "Selection Mode:",0
 .db 28,15
 .db "Tray Status:",0
 .db 48,41
 .db "Change: [2ND]",0
 .db 56,33
 .db "Main Menu: [MORE]",0
PieceSizeText:
 .db 10,74
 .db "16x16",0
 .db 10,103
 .db "8x8",0
SelectionModeText:
 .db 19,73
 .db "Cursor",0
 .db 19,97
 .db "Outline",0
TrayStatusText:
 .db 28,80
 .db "On",0
 .db 28,104
 .db "Off",0
CompleteText:
 .db 0,3
 .db "Puzzle Complete",0
 .db 3,3
 .db "Time:  00:00:00",0
 .db 5,3
 .db "Sneak Peaks: 00",0
HighScoreTxt:
 .db 0,2
 .db "A New High Score!",0
 .db 2,1
 .db "Enter Your Initials",0
HighScoreTableTxt:
 .db 3,1
 .db "16, Cur, Tray",0
 .db 10,1
 .db "16, Cur, No Tray",0
 .db 17,1
 .db "16, Out, Tray",0
 .db 24,1
 .db "16, Out, No Tray",0
 .db 31,1
 .db "8, Cur, Tray",0
 .db 38,1
 .db "8, Cur, No Tray",0
 .db 45,1
 .db "8, Out, Tray",0
 .db 52,1
 .db "8, Out, No Tray",0
HighScoreInits:
 .db 3,61
 .db "---",0
 .db 10,61
 .db "---",0
 .db 17,61
 .db "---",0
 .db 24,61
 .db "---",0
 .db 31,61
 .db "---",0
 .db 38,61
 .db "---",0
 .db 45,61
 .db "---",0
 .db 52,61
 .db "---",0
HighScoreTimes:
 .db 3,85
 .db "--:--:--",0
 .db 10,85
 .db "--:--:--",0
 .db 17,85
 .db "--:--:--",0
 .db 24,85
 .db "--:--:--",0
 .db 31,85
 .db "--:--:--",0
 .db 38,85
 .db "--:--:--",0
 .db 45,85
 .db "--:--:--",0
 .db 52,85
 .db "--:--:--",0
HighScorePeaks:
 .db 3,118
 .db "--",0
 .db 10,118
 .db "--",0
 .db 17,118
 .db "--",0
 .db 24,118
 .db "--",0
 .db 31,118
 .db "--",0
 .db 38,118
 .db "--",0
 .db 45,118
 .db "--",0
 .db 52,118
 .db "--",0
;
ExitMenuText:
 .db 4
 .db 0,8
 .db "Exit  Menu",0
 .db 12,27
 .db "[F1]: Exit Puzzle",0
 .db 22,27
 .db "[F2]: Exit Program",0
 .db 32,27
 .db "[F3]: Save And Quit",0
 .db 42,27
 .db "[F4]: Turn off Calc",0
 .db 52,27
 .db "[EXIT]: Return To Game",0
