SECONDS_COUNTDOWN = 180                      ;180 interrupt runs in 1 second

int_table = $F700

;Installs gray scale interrupt
OpenGray:

InstallInterrupt:
 ld hl,int_copy
 ld de,$F8F8
 ld bc,int_end-int_start
 ldir
 ld hl,int_table
 ld (hl),$F8
 ld de,int_table+1
 inc b
 ldir
 ld a,int_table/256
 ld i,a

 xor a
 ld (GrayCounter),a
 dec a
 ld (IntCount),a

 im 2

 ret

;De-Installs interrupt
CloseGray:
 im 1
 ld a,$3C
 out (0),a      ;display vid mem
 ret

ClearMem:
 ld hl,PAGE1ADDR
 call Clear
 ld hl,PAGE2ADDR
 call Clear
ClearBuffers:
 ld hl,PAGE1BUFFER
 call Clear
 ld hl,PAGE2BUFFER
Clear:
 ld d,h
 ld e,l
 inc de
 ld (hl),0
 ld bc,1024-1
 ldir
 ret

StartTimer:
 ld hl,IntCount
 ld (hl),SECONDS_COUNTDOWN
 ret
StopTimer:
 ld hl,IntCount
 ld (hl),$FF
 ret

int_copy:
.org $F8F8
int_start:
 exx
 ex af,af'
 in a,(3)
 bit 3,a
 jr z,no_down_left_bug
 and %11111110
 out (3),a
no_down_left_bug:
 bit 1,a
 jr z,no_swap
; in a,(3)                                         ;if bit 1 in port 3 is set 
; bit 1,a                                          ;the LCD is updating so leave 
; jr z,Int_Done                                    ;this won't happen unless the batteries are very low 
 ld hl,GrayCounter
 inc (hl)
 ld a,(hl)
 cp 3
 ld a,(PAGE1ADDR/$100)-$C0
 jr c,set_video_port
 ld a,(PAGE2ADDR/$100)-$C0
 ld (hl),0
set_video_port:
;*      When 'out'ing something to port 0 (the video port) the address of
;where to display is determined by $100 * ($C0 + x), where x is the byte
;outputted to the port.
 out (0),a
no_swap:
;more space to put more interrupt code ;)
 ld hl,IntCount
 ld a,(hl)
 inc a
 jp z,$3A
 dec (hl)
 ld a,(hl)
 or a
 jp nz,$3A
 ld (hl),SECONDS_COUNTDOWN
 ld hl,TimerSecs
 inc (hl)
 ld a,(hl)
 cp 60
 jp c,$3A
 ld (hl),0
 inc hl
 inc (hl)
 ld a,(hl)
 cp 60
 jp c,$3A
 ld (hl),0
 inc hl
 inc (hl)
;End misc. interrupt code.
 jp $3A
;If jumps to $3A, allow user im 1 interrupts to run with the default interrupt.
;If jumps to $66, keep the usual interrupt going without the ability for user im 1 interrupts to execute.
int_end:
